function canInsert(_entity, _index, _stack)
	-- NOTE: if checking the hotbar and the player has their hotbar filtered and there's nothing in the filtered slot caninsert will return true for that slot
	local stackSize = game.itemprototypes[_stack.name].stacksize
	local results = {["count"] = 0, ["slots"] = 0}
	local toInsertCount = _stack.count
	
	if toInsertCount ~= 0 then
		for _,index in pairs(_index) do
			inventoryContents = _entity.getinventory(index)
			
			for slot = 1,#inventoryContents do
				contents = inventoryContents[slot]
				
				if contents ~= nil then
					-- Slot with contents
					if contents.name == _stack.name then
						if contents.count < stackSize then
							if toInsertCount >= stackSize - contents.count then
								results["count"] = results["count"] + (stackSize - contents.count)
								toInsertCount = toInsertCount - (stackSize - contents.count)
							else
								results["count"] = results["count"] + toInsertCount
								toInsertCount = 0
								break
							end
						end
					end
				else
					-- Empty slot
					results["slots"] = results["slots"] + 1
					
					if toInsertCount >= stackSize then
						results["count"] = results["count"] + stackSize
						toInsertCount = toInsertCount - stackSize
					else
						results["count"] = results["count"] + toInsertCount
						toInsertCount = 0
						break
					end
				end
			end
			
			if toInsertCount == 0 then
				break
			end
		end
	end
	
	return results
end